---
Title: sqlmap
Homepage: https://sqlmap.org/
Repository: https://salsa.debian.org/pkg-security-team/sqlmap
Architectures: all
Version: 1.9.2-1
Metapackages: kali-linux-default kali-linux-everything kali-linux-headless kali-linux-large kali-linux-nethunter kali-tools-database kali-tools-exploitation kali-tools-information-gathering kali-tools-top10 kali-tools-vulnerability kali-tools-web 
Icon: images/sqlmap-logo.svg
PackagesInfo: |
 ### sqlmap
 
  sqlmap goal is to detect and take advantage of SQL injection
  vulnerabilities in web applications. Once it detects one or more SQL
  injections on the target host, the user can choose among a variety of
  options to perform an extensive back-end database management system
  fingerprint, retrieve DBMS session user and database, enumerate users,
  password hashes, privileges, databases, dump entire or user's specific
  DBMS tables/columns, run his own SQL statement, read specific files on
  the file system and more.
 
 **Installed size:** `10.63 MB`  
 **How to install:** `sudo apt install sqlmap`  
 
 {{< spoiler "Dependencies:" >}}
 * python3
 * python3-magic
 {{< /spoiler >}}
 
 ##### sqlmap
 
 Automatic SQL injection tool
 
 ```
 root@kali:~# sqlmap -h
         ___
        __H__
  ___ ___[']_____ ___ ___  {1.9.2#stable}
 |_ -| . [)]     | .'| . |
 |___|_  [(]_|_|_|__,|  _|
       |_|V...       |_|   https://sqlmap.org
 
 Usage: python3 sqlmap [options]
 
 Options:
   -h, --help            Show basic help message and exit
   -hh                   Show advanced help message and exit
   --version             Show program's version number and exit
   -v VERBOSE            Verbosity level: 0-6 (default 1)
 
   Target:
     At least one of these options has to be provided to define the
     target(s)
 
     -u URL, --url=URL   Target URL (e.g. "http://www.site.com/vuln.php?id=1")
     -g GOOGLEDORK       Process Google dork results as target URLs
 
   Request:
     These options can be used to specify how to connect to the target URL
 
     --data=DATA         Data string to be sent through POST (e.g. "id=1")
     --cookie=COOKIE     HTTP Cookie header value (e.g. "PHPSESSID=a8d127e..")
     --random-agent      Use randomly selected HTTP User-Agent header value
     --proxy=PROXY       Use a proxy to connect to the target URL
     --tor               Use Tor anonymity network
     --check-tor         Check to see if Tor is used properly
 
   Injection:
     These options can be used to specify which parameters to test for,
     provide custom injection payloads and optional tampering scripts
 
     -p TESTPARAMETER    Testable parameter(s)
     --dbms=DBMS         Force back-end DBMS to provided value
 
   Detection:
     These options can be used to customize the detection phase
 
     --level=LEVEL       Level of tests to perform (1-5, default 1)
     --risk=RISK         Risk of tests to perform (1-3, default 1)
 
   Techniques:
     These options can be used to tweak testing of specific SQL injection
     techniques
 
     --technique=TECH..  SQL injection techniques to use (default "BEUSTQ")
 
   Enumeration:
     These options can be used to enumerate the back-end database
     management system information, structure and data contained in the
     tables
 
     -a, --all           Retrieve everything
     -b, --banner        Retrieve DBMS banner
     --current-user      Retrieve DBMS current user
     --current-db        Retrieve DBMS current database
     --passwords         Enumerate DBMS users password hashes
     --dbs               Enumerate DBMS databases
     --tables            Enumerate DBMS database tables
     --columns           Enumerate DBMS database table columns
     --schema            Enumerate DBMS schema
     --dump              Dump DBMS database table entries
     --dump-all          Dump all DBMS databases tables entries
     -D DB               DBMS database to enumerate
     -T TBL              DBMS database table(s) to enumerate
     -C COL              DBMS database table column(s) to enumerate
 
   Operating system access:
     These options can be used to access the back-end database management
     system underlying operating system
 
     --os-shell          Prompt for an interactive operating system shell
     --os-pwn            Prompt for an OOB shell, Meterpreter or VNC
 
   General:
     These options can be used to set some general working parameters
 
     --batch             Never ask for user input, use the default behavior
     --flush-session     Flush session files for current target
 
   Miscellaneous:
     These options do not fit into any other category
 
     --wizard            Simple wizard interface for beginner users
 
 [!] to see full list of options run with '-hh'
 ```
 
 - - -
 
 ##### sqlmapapi
 
 Automatic SQL injection tool, api server
 
 ```
 root@kali:~# sqlmapapi -h
 Usage: sqlmapapi [options]
 
 Options:
   -h, --help            show this help message and exit
   -s, --server          Run as a REST-JSON API server
   -c, --client          Run as a REST-JSON API client
   -H HOST, --host=HOST  Host of the REST-JSON API server (default "127.0.0.1")
   -p PORT, --port=PORT  Port of the REST-JSON API server (default 8775)
   --adapter=ADAPTER     Server (bottle) adapter to use (default "wsgiref")
   --database=DATABASE   Set IPC database filepath (optional)
   --username=USERNAME   Basic authentication username (optional)
   --password=PASSWORD   Basic authentication password (optional)
 ```
 
 - - -
 
---
{{% hidden-comment "<!--Do not edit anything above this line-->" %}}

## sqlmap Usage Example

Attack the given URL (`-u “http://192.168.1.250/?p=1&forumaction=search”`) and extract the database names (`–dbs`):

```console
root@kali:~# sqlmap -u "http://192.168.1.250/?p=1&forumaction=search" --dbs
        ___
       __H__
 ___ ___[)]_____ ___ ___  {1.2.11#stable}
|_ -| . ["]     | .'| . |
|___|_  ["]_|_|_|__,|  _|
      |_|V          |_|   http://sqlmap.org

[!] legal disclaimer: Usage of sqlmap for attacking targets without prior mutual consent is illegal. It is the end user's responsibility to obey all applicable local, state and federal laws. Developers assume no liability and are not responsible for any misuse or damage caused by this program

[*] starting at 13:37:00

[13:37:00] [INFO] testing connection to the target URL
```
